/MSP,++,/XMD,++,OR,--,MO; set message suppress on, expert mode on, ortho mode off, manual entry origin
/VLC,P,7,I,2,R,9,S,6,!; allocate variables
/SYS,C,Y,/VST,0,$STR; gather display unit setting into $S(0)
/SYS,C,D,UN,$STR; gather database unit setting into $STR and set display units to same
/VRL,3,0,/VRL,4,0,CR,0;
/PMT,1,'^^Printer Type: (^MA^^) Dot Matrix (^MB^^) Laser (^MC^^) Postscript (^MQ^^)uit',#/CIN;
; above line prompts for printer type
/IF,$VAL[EQ]1,/GOTO,DOT; if dot matrix, go to dot routine
/IF,$VAL[EQ]2,/VRL,1,10,/VRL,0,8,/VIN,1,2,/GOTO,COMP;
; if laser, set paper length $R(1) to 10 and width $R(0) to 8, set printer type $I(1) to 2, go to comp routine
/IF,$VAL[EQ]3,/VRL,1,10.5,/VRL,0,8,/VIN,1,3,/GOTO,COMP;
; if postscript, set paper length $R(1) to 10.5 and width $R(0) to 8, set printer type $I(1) to 3, go to comp routine
/IF,$VAL[EQ]4,/GOTO,EXIT; if quit, exit macro
.DOT; sets paper size for dotmatrix printers
/PMT,1,'^^Paper Size:   (^MA^^) 8 x 10    (^MB^^) 13.5 x 10    (^MQ^^)uit',#/CIN;
; above line prompts for paper size
/IF,$VAL[EQ]1,/VRL,1,11,/VRL,0,8,/VIN,1,1; if 8x10, set length ($R(1)) to 11 and width ($R(0)) to 8, set printer type to 1
/IF,$VAL[EQ]2,/VRL,1,11,/VRL,0,13.5,/VIN,1,1; if 13.5x10, set length ($R(1)) to 11 and width ($R(0)) to 13.5, set printer type to 1
/IF,$VAL[EQ]3,/GOTO,EXIT; if quit, exit macro
/PMT,1,'',#; clear prompt line
.COMP;
OD,--; turn object drag off for next section, this is only for escthetics
/EXT,E,0,1,D,!; gather the extents of the drawing, lower left into $X(0),$Y(0) and upper right into $X(1),$Y(1)
LK,10,RE,$X(0)-100,$Y(0)-100,$X(0)-(100-$R(0)),$Y(0)-(100-$R(1));
; above line creates rectangle that equals paper size ($R(0),$R(1))
CC,W,$X(0)-100,$Y(0)-100,$X(0)-(100-$R(0)),$Y(0)-(100-$R(1)),!,TILE,$X(0)-100,$Y(0)-100,!;
; above line creates component out of above rectangle
WE,$X(0)-101,$Y(0)-101,$X(0)-(90-$R(0)),$Y(0)-(90-$R(1));
; above line erases rectangle
/PMT,1,Enter Scale for Print (1):_,#; prompt for scale to print at
/VRL,5,~; gathers scale into $R(5)
CZ,$R(5),$R(5); set component scale to print scale
/PMT,1,Choose Overlap amount,#; prompt for overlap amount
/PMT,3,'^^(^MA^^) 1//8 inch  (^MB^^) 1//4 inch  (^MC^^) 1//2 inch  (^MD^^) None',#/CIN;
; three choices given for overlap
/IF,$VAL[EQ]1,/VRL,2,(.125*$R(5));
/IF,$VAL[EQ]2,/VRL,2,(.25*$R(5));
/IF,$VAL[EQ]3,/VRL,2,(.5*$R(5));
/IF,$VAL[EQ]4,/VRL,2,0; if quit, exit macro
/PMT,1,'',#,/PMT,3,'',#; clear prompts
/VRL,6,$Y(1)/($R(5)*10); $R(6) will be number of verticle tiles needed
/VRL,7,($R(6)+1)*11; $R(7) will be length of paper for dot matrix
/VRL,8,$X(1)/($R(5)*$R(0)); $R(8) will be number of horizontal tiles needed
CP,TILE,$X(0),$Y(0); place the first tile at the lower left corner of the drawing (gather from extents command)
SE,F,M,!,N,TILE,!,D,!; select the tile component
CO,L,!,$X(0),$Y(0),$X(0),$Y(0)+($R(5)*$R(1)),$R(6); copy this tile vertically $R(6) times
CO,L,!,$X(0),$Y(0),$X(0)+($R(5)*$R(0)),$Y(0),$R(8); copy this tile horizontally $R(8) times
ZA,/GOTO,MOVE; zoom all
.MOVE; this routine will allow you to position tile arrangement or choose new scale
OD,++; turn object drag on so you can see positioning
/PMT,1,'^^Tile(s) Position:   ^MA^^ccept   ^MC^^hange   ^MR^^escale   ^MQ^^uit',#/CIN;
; above line prompts you to accept tile position, change it, change scale of print or quit
/IF,$VAL[EQ]2,MV,L,!,$X(0),$Y(0),@,ZA,/GOTO,MOVE;
; if change is selected, initiate move of tiles
/IF,$VAL[EQ]3,CX,TILE,/GOTO,COMP; if rescale is selected, remove the tile component and go back to comp routine
/IF,$VAL[EQ]4,CX,TILE,/GOTO,EXIT; if quite, exit macro
/EXT,E,2,3,D,!; gather extents of drawing with tiles positioned as desired
/VPT,4,$X(2),$Y(2);
ZW,$X(2)-100,$Y(2)-100,$X(2)-101,$Y(2)-101,CX,TILE;
; zoom to small area for quicker redraws and remove the tile component so it will not print
/IF,$I(1)[EQ]1,/VRL,1,$R(7),DP,1,2,3,U,$R(7),$R(0),#,#;
; if printer type 1 (dot matrix) then set paper length to $R(7), dp and set printer type and paper width and length
/IF,$I(1)[EQ]2,DP,1,2,#; if printer type 2 (laser), dp and set printer type
/IF,$I(1)[EQ]3,DP,1,3,#; if printer type 3 (postscript), dp and set printer type
LB,PRINT2EX;
